> For the complete documentation index, see [llms.txt](https://docs.warpstream.com/warpstream/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.warpstream.com/warpstream/reference/integrations/timeplus.md).

# Timeplus

This page describes how to integrate WarpStream with Timeplus, to perform SQL commands on a data stream to perform queries, transformations and ETL.

A video walkthrough can be found below:

{% embed url="<https://youtu.be/NbgKjsUhVxc>" %}

Timeplus is a streaming-first data analytics platform based on the open-source project Proton that integrates with WarpStream to ingest data from your WarpStream topics. For more information on configuring Timeplus to consume data from WarpStream, please review the [Timeplus Proton integration documentation](https://docs.timeplus.com/tutorial-sql-connect-kafka#connect-warp).

You can connect Proton with a local deployment of WarpStream or WarpStream Serverless Cloud.

Example:

```
CREATE EXTERNAL STREAM ext_stream(raw string)
SETTINGS type='kafka',
         brokers='serverless.warpstream.com:9092',
         topic='topic',
         security_protocol='SASL_SSL',
         sasl_mechanism='PLAIN',
         username='..',
         password='..'
```

`sasl_mechanism` can be either `PLAIN` or `SCRAM-SHA-512`, but cannot be `SCRAM-SHA-256`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.warpstream.com/warpstream/reference/integrations/timeplus.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
